package cokr.xit.fims.sndb.service;

import java.util.List;

import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.Sndng;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.fims.sndb.Svbtc;
import cokr.xit.foundation.data.DataObject;

/**발송 대장 관리 서비스 인터페이스.
*
* <p>상세 설명:
*
* <pre>
* ============ 변경 이력 ============
* 2023-08-25	JoJH 최초 작성
* ================================
* </pre>
*/
public interface Sndb01Service {

	/**지정한 조건에 따라 발송 대장 목록을 조회하여 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 목록
	 */
	List<DataObject> getSndngList(SndbQuery req);

	/**지정한 조건에 따라 발송 대장 객체들을 반환한다.
	 * @param req 발송 대장 조회 조건
	 * @return 발송 대장 객체 목록
	 */
	List<DataObject> getSndngs(SndbQuery req);

	/**발송 대장 정보를 등록한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean createSndng(Sndng sndng);

	/**발송 대장 정보를 수정한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean updateSndng(Sndng sndng);

	/**발송 대장 정보를 삭제한다.
	 * @param sndng 발송 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean removeSndng(Sndng sndng);

	/**지정한 조건에 따라 발송 상세 목록을 조회하여 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 목록
	 */
	List<DataObject> getSndngDtlList(SndbQuery req);

	/**지정한 조건에 따라 발송 상세 객체들을 반환한다.
	 * @param req 발송 상세 조회 조건
	 * @return 발송 상세 객체 목록
	 */
	List<DataObject> getSndngDtls(SndbQuery req);

	/**발송 상세 정보를 등록한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean createSndngDtl(SndngDtl sndngDtl);

	/**발송 상세 정보를 수정한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean updateSndngDtl(SndngDtl sndngDtl);

	/**발송 상세 정보를 삭제한다.
	 * @param sndngDtl 발송 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean removeSndngDtl(SndngDtl sndngDtl);

	/**지정한 조건에 따라 공시송달 대장 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	List<DataObject> getSvbtcList(SndbQuery req);

	/**지정한 조건에 따라 공시송달 대장 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	List<DataObject> getSvbtcs(SndbQuery req);

	/**공시송달 대장 정보를 등록한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean createSvbtc(Svbtc svbtc);

	/**공시송달 대장 정보를 수정한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean updateSvbtc(Svbtc svbtc);

	/**공시송달 대장 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	boolean removeSvbtc(Svbtc svbtc);

}
